//////////////////////////////////////////////////////////////////////
// simpleTree.cpp
// -Kyoung Shin Park (2016 Fall)
//////////////////////////////////////////////////////////////////////
#include "SimpleTree.h"
#include "material.h"

namespace moglclass
{

SimpleTree::SimpleTree()
{
	init();
}

void SimpleTree::init()
{
	body[0] = new Cylinder(glm::vec3(0, 0, 0), 1.0f, 1.0f, 3.0f, 16);
	body[1] = new Cylinder(glm::vec3(0, 3, 0), 3.0f, 1.0f, 2.0f, 16);
	body[2] = new Cylinder(glm::vec3(0, 5, 0), 2.0f, 0.1f, 1.5f, 16);
}

SimpleTree::~SimpleTree()
{
	for (int i = 0; i < 3; i++) {
		if (body[i]) delete body[i];
	}
	std::cout << "~SimpleTree" << std::endl;
}

void SimpleTree::draw(Program* p, glm::mat4& projection, glm::mat4& view, glm::mat4& model)
{
	p->useProgram();
	p->setUniform("gProjection", projection);
	p->setUniform("gView", view);

	glm::mat4 mMatrix = model;
	p->setUniform("gModel", mMatrix);
	Material::DarkBrownMaterial.setUniform(p, "gMaterial");
	if (body[0]) body[0]->draw();
	Material::GreenMaterial.setUniform(p, "gMaterial");
	if (body[1]) body[1]->draw();
	Material::CyanMaterial.setUniform(p, "gMaterial");
	if (body[2]) body[2]->draw();
}

bool SimpleTree::update(float deltaTime)
{

	return true;
}

}