// material class
// -Kyoung Shin Park (2014 Spring)
//////////////////////////////////////////////////////////////////////
#ifndef __MATERIAL_H__
#define __MATERIAL_H__

#include "moglclass.h"
#include "shaders.h"
#include "color.h"

namespace moglclass
{

class Material
{
public:
	static const Material WhiteMaterial;
	static const Material BlackMaterial;
	static const Material RedMaterial;
	static const Material GreenMaterial;
	static const Material BlueMaterial;
	static const Material CyanMaterial;
	static const Material MagentaMaterial;
	static const Material YellowMaterial;
	
	static const Material SkyBlueMaterial;
	static const Material NavyBlueMaterial;
	static const Material YellowGreenMaterial;
	static const Material DarkGreenMaterial;
	static const Material DarkYellowMaterial;
	static const Material MaroonMaterial;
	static const Material RedBrownMaterial;
	static const Material DarkBrownMaterial;
	static const Material GrayBrownMaterial;
	static const Material OrangeMaterial;
	static const Material LavenderMaterial;
	static const Material PinkMaterial;

    Material(void);
    Material(glm::vec4& ambientAndDiffuse);
    Material(glm::vec4& ambientAndDiffuse, glm::vec4& specular, float shininess);
    Material(glm::vec4& ambient, glm::vec4& diffuse, glm::vec4& specular, float shininess);
	Material(const Color& ambient, const Color& diffuse, const Color& specular, float shininess);
	void setUniform(Program* p, std::string materialName) const;
	void setUniform(Program* p, std::string materialName);

    void setAmbient(glm::vec4& ambient);
    void setDiffuse(glm::vec4& diffuse);
    void setAmbientAndDiffuse(glm::vec4& ambientAndDiffuse);
    void setSpecular(glm::vec4& specular);
    void setEmission(glm::vec4& emission);
    void setShininess(float shininess);

    glm::vec4 Ambient, Diffuse, Specular, Emission;
    float Shininess;
};

} // namespace

#endif
