#pragma once
//////////////////////////////////////////////////////////////////////
// car.h: interface for the Car class.
// -Kyoung Shin Park (2013 Spring)
//////////////////////////////////////////////////////////////////////
#include "moglclass.h"
#include "geometryPositionNormal.h"
#include "shaders.h"
#include <glm/gtc/type_ptr.hpp>
#include <glm/gtc/matrix_transform.hpp>

namespace moglclass
{

class SimpleCar
{
public:
	SimpleCar();
	~SimpleCar();
	void init();
    void draw(Program* p, glm::mat4& projection, glm::mat4& view, glm::mat4& model);
	bool update(float dt);

	void activate() { active = true; }
	void deactivate() { active = false; }
	bool isActive() { return active; }
	void toggleActivate() { active = !active; }

protected:
	Parallelepiped * body;
	Torus * wheel;
	
	glm::vec3 position;
	float direction; // positive/negative direction
	float angle;// wheel angle

	glm::mat4 bodyTransform;
	glm::mat4 wheelTransform[4];

	bool active;
};

} // moglclass namespace