#pragma once
//////////////////////////////////////////////////////////////////////
// cube3d.h: interface for the Car class.
// -Kyoung Shin Park (2016 Fall)
//////////////////////////////////////////////////////////////////////
#include "moglclass.h"
#include "geometryPositionNormal.h"
#include "shaders.h"
#include <glm/gtc/type_ptr.hpp>
#include <glm/gtc/matrix_transform.hpp>

namespace moglclass
{

class SimpleCube3d
{
public:
	SimpleCube3d();
	~SimpleCube3d();
	void init();
    void draw(Program* p, glm::mat4& projection, glm::mat4& view, glm::mat4& model);
	bool update(float dt);
	void activate() { active = true; }
	void deactivate() { active = false; }

protected:
	Quad * face;

	float angle;// face unfolding angle
	bool active;

	glm::mat4 faceTransform[5];
	void updateTransform();
};

} // moglclass namespace